-- module internal data
local internaldata = {}

internaldata.screen_modes = {
	{ width =  320, height = 240 },
	{ width =  640, height = 480 },
	{ width =  800, height = 600 },
	{ width = 1024, height = 768 },
}
internaldata.width  = 800
internaldata.height = 600
internaldata.fullscreen = false
internaldata.caption = "NotSet"

local newFont = function(name, size)
  return {
    getWidth = function(self, text) return #text * size end,
    getHeight = function(self, text) return size end,
  }
end

love.graphics.checkMode = function(width, height, fullscreen)
	return true
end
--[[
love.graphics.circle = TODO
]]--
love.graphics.clear = TODO
--[[
love.graphics.draw = TODO
love.graphics.drawq = TODO
love.graphics.getBackgroundColor = TODO
love.graphics.getBlendMode = TODO
]]--
love.graphics.getCaption = function()
	return internaldata.caption
end
--[[
love.graphics.getColor = TODO
love.graphics.getColorMode = TODO
love.graphics.getFont = TODO
love.graphics.getHeight = TODO
love.graphics.getLineStipple = TODO
love.graphics.getLineStyle = TODO
love.graphics.getLineWidth = TODO
love.graphics.getMaxPointSize = TODO
]]--
love.graphics.getModes = function()
	return internaldata.screen_modes
end
--[[
love.graphics.getPointSize = TODO
love.graphics.getPointStyle = TODO
love.graphics.getScissor = TODO
love.graphics.getWidth = TODO
]]--
love.graphics.isCreated = function() return true end
--[[
love.graphics.line = TODO
]]--
love.graphics.newFont = newFont
--[[
love.graphics.newFramebuffer = TODO
love.graphics.newImage = TODO
love.graphics.newImageFont = TODO
love.graphics.newParticleSystem = TODO
love.graphics.newQuad = TODO
love.graphics.newScreenshot = TODO
love.graphics.newSpriteBatch = TODO
love.graphics.point = TODO
love.graphics.polygon = TODO
love.graphics.pop = TODO
love.graphics.present = TODO
love.graphics.print = TODO
love.graphics.printf = TODO
love.graphics.push = TODO
love.graphics.quad = TODO
love.graphics.rectangle = TODO
love.graphics.reset = TODO
love.graphics.rotate = TODO
love.graphics.scale = TODO
]]--
love.graphics.setBackgroundColor = TODO
love.graphics.setBlendMode = TODO
love.graphics.setCaption = function(title)
	internaldata.caption = title
end
love.graphics.setColor = TODO
--[[
love.graphics.setColorMode = TODO
]]--
love.graphics.setFont = TODO
--[[
love.graphics.setIcon = TODO
love.graphics.setLine = TODO
love.graphics.setLineStipple = TODO
love.graphics.setLineStyle = TODO
love.graphics.setLineWidth = TODO
]]--
love.graphics.setMode = function(width, height, fullscreen, vsync, fsaa)
	local success = true
	if success then
		internaldata.width  = width
		internaldata.height = height
		internaldata.fullscreen = fullscreen
	end
	return success
end
--[[
love.graphics.setPoint = TODO
love.graphics.setPointSize = TODO
love.graphics.setPointStyle = TODO
]]--
love.graphics.setRenderTarget = TODO
love.graphics.setScissor = TODO
love.graphics.toggleFullscreen = function(...)
	local success = true
	if success then
		internaldata.fullscreen = not internaldata.fullscreen
	end
	return success
end
--[[
love.graphics.translate = TODO
love.graphics.triangle = TODO
]]--

-- register the internal data into main table
getInternalDataTable().graphics = internaldata

